/************************************************************
	t@C:main,c
	Tv:_Ci~bN_
	^[Qbg:PIC16F88(20MHz)
	|[gA:
	|[gB:
	쐬:2012/03/02
************************************************************/

#include <pic.h>

#define     _XTAL_FREQ  20000000

#define     T1S	38		//1sec = 0.05usec x4 x256 x256 x 38

//}N֐
//7ZÕRONɂ(n = 0`9, d = 0:ŏʌ - 3:őʌ)
#define	SEG_ON(n, d)		(PORTB = 0x80 | ((d << 5) & 0x60) | (n & 0x0F)) 
#define	SEG_ON_DP(n, d)	(PORTB = 0x90 | ((d << 5) & 0x60) | (n & 0x0F)) 
#define	SEG_OFF()         (PORTB &= 0x7F)
#define	DP(n)			((unsigned char)(0x01 << n))

//RtBO[Vrbg̐ݒ
__CONFIG(HS & WDTDIS & PWRTDIS & MCLREN & BORDIS &
		LVPDIS & DEBUGDIS & CCPRB0 & UNPROTECT); 	//Configration1
__CONFIG(FCMDIS & IESODIS);


//vg^Cv錾
void interrupt irt(void);
void io_init(void);
void tmr0_init(void);
void tmr1_init(void);
void ad_init(unsigned char chbit);
unsigned short ad_get(unsigned char ch);

//O[oϐE萔
unsigned char seg[4];	//7ZOLEDpz(0`9)
unsigned char dp;		//7ZOLEDDp(4bit)
unsigned short sec = 0;	//oߎ

//main֐
void main(void)
{
	unsigned short dispdata;	//\p
	    
    io_init();				//I/Ȍ
    tmr0_init();				//^C}0̏
    tmr1_init();
	ad_init(0x03);			//A/D̏

	//݂̐ݒ
	TMR0IF = 0;				//TMR0݃tOZbg
	TMR0IE = 1;				//TMR0݋
	PEIE = 1;
	GIE = 1;					//S݋

    while (1) {				//
		switch (PORTA & 0x0C) {
			
			case 0x0C:	//PSW2:OFF, PSW3:OFF
				dispdata = (short long)ad_get(1) * 5000 / 1024;
				dp = DP(2);
				break;
			case 0x08:	//PSW2:ON, PSW3:OFF
				dispdata = (short long)ad_get(0) * 5000 / 1024;
				dp = DP(3);
				break;
			case 0x04:	//PSW2:OFF, PSW3:ON
				dispdata = (short long)ad_get(1) * 5000 / 1024;
				dp = DP(3);
				break;
			default:		//PSW2:ON, PSW3:ON
				dispdata = sec;	
				dp = 0;
		}
		//e̎Zo(10i)
		seg[3] = dispdata / 1000;
		seg[2] = dispdata % 1000 / 100;
		seg[1] = dispdata % 100 / 10;
		seg[0] = dispdata % 10;
		__delay_ms(100);
	}
}

//I/O֐
void io_init(void)
{
	ANSEL = 0x03;				//A/D͂SDIOŎgp
	TRISA = 0x0F;				//PORTA
	TRISB = 0x00;				//PORTBSo
	PORTB = 0x00;				//7ZO͑SOFF()
}

/*	
	֐:ad_init
	Tv:A/DϊsȂ`lw肵ďݒKp(00`FF)
	chbit:A/DϊsȂ`l2iŎw
	߂l:Ȃ
	l:ch=0x12ȂRA4RA1I
		dVDDVSSɂϊƂ
*/
void ad_init(unsigned char chbit)
{
	ANSEL = chbit;	//AiO͂I
	ADCS2 = 1; ADCS1 = 1; ADCS0 = 0;	//64 TOSC
	VCFG1 = 0; VCFG0 = 0;		//Vdd-Vssɂd
	ADFM = 1;	//f[^El
	ADON = 1;	//A/DϊJn
}

/*
	֐:ad_get
	Tv:A/DϊsȂ`lw肵Čʂ擾֐
	chbit:A/DϊsȂ`l0`7Ŏw
	߂l:A/Dϊ̃fBW^l(0`5V0`1023ɕϊ)
*/
unsigned short ad_get(unsigned char ch)
{
	unsigned short addata;
	//A/Dϊ`lw
	CHS2 = (ch & 0x04) >> 2;
	CHS1 = (ch & 0x02) >> 1;
	CHS0 = (ch & 0x01) >> 0;
		
	__delay_us(20);	//ANBWV^C
	
	GODONE = 1;			//GODONE1ɂĕϊJn
	while (GODONE);		//ϊI(GODONE0)܂ő҂
	//El߂ꂽ2bit8bitVtgČ
	addata = ((ADRESH << 8) | ADRESL);
	return addata;
}

//^C}0֐
void tmr0_init(void)
{
    	T0CS = 0;				//VXeNbNJEg
	PSA = 0;					//vXP[gp
	PS0 = 1;					//vXP[1/256
	PS1 = 1;
	PS2 = 1;
}

//^C}1֐
void tmr1_init(void)
{
	T1CKPS0 = 0;				//vXP[1:1
	T1CKPS1 = 0;
	T1OSCEN = 0;				//OIV[^p[It
	TMR1CS = 0;				//Fosc/4(0.2us)gp
	TMR1ON = 1;				//^C}L
	TMR1IF = 0;				//tO
	TMR1IE = 1;				//݋
	TMR1L = 0xF0;				//65536 - 10000 = 56566 = 0xD8F0
	TMR1H = 0xD8;				//0.2us x 10000 = 2ms
}

//݊֐
void interrupt irt(void)
{
	static unsigned short count = 0;		//1bJEgÓIϐ
	static unsigned char i = 0;			//̐ؑ֗pÓIϐ

	//^C}0(13msɔ)
	if (TMR0IF) {						//TMR0tOo
		if (count++ >= T1S) {			//1bȏJEgナZbg
			count = 0;				//JE^
			if (sec++ >= 9999) {		//9999bȏJEgナZbg
				sec = 0;				//JE^
			}
		}
		TMR0IF = 0;					//TMR0tO
	}

	//^C}1(2msɔ)
	if (TMR1IF) {					//TMR1tOo
		if (i++ >= 3) {			//3\ςo
			i = 0;				//
		}
		SEG_OFF();				//
		if ((dp >> i) & 0x01) {	//hbg|Cg̗L
			SEG_ON_DP(seg[i], i);	//hbg|Cg܂߂ĕ\
		}
		else {
			SEG_ON(seg[i], i);	//hbg|CgȂŕ\
		}
		TMR1IF = 0;					//TMR1tO
		TMR1L = 0xF0;					//^C}1
		TMR1H = 0xD8;
	}
}
